'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _model = require('@react-sharedb/model');

var _model2 = _interopRequireDefault(_model);

var _Base2 = require('./Base');

var _Base3 = _interopRequireDefault(_Base2);

var _util = require('../util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Local = function (_Base) {
  (0, _inherits3.default)(Local, _Base);

  function Local() {
    var _ref;

    (0, _classCallCheck3.default)(this, Local);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var _this = (0, _possibleConstructorReturn3.default)(this, (_ref = Local.__proto__ || (0, _getPrototypeOf2.default)(Local)).call.apply(_ref, [this].concat(args)));

    var _this$params = (0, _slicedToArray3.default)(_this.params, 4),
        path = _this$params[0],
        fn = _this$params[1],
        inputs = _this$params[2],
        options = _this$params[3];

    _this.path = path;
    _this.fn = fn;
    _this.inputs = inputs || [];
    _this.options = options || {};
    _this.listeners = [];
    return _this;
  }

  (0, _createClass3.default)(Local, [{
    key: 'init',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(firstItem) {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this._fetch(firstItem);

              case 2:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function init(_x) {
        return _ref2.apply(this, arguments);
      }

      return init;
    }()
  }, {
    key: 'refModel',
    value: function refModel() {
      if (this.cancelled) return;
      var key = this.key;

      if (this.path) {
        _model2.default.setDiff(this.path, this.data);
        (0, _util.observablePath)(this.path);
        this.model.ref(key, _model2.default.scope(this.path));
      } else {
        this.model.setDiff(key, this.data);
      }
    }
  }, {
    key: 'unrefModel',
    value: function unrefModel() {
      var key = this.key;

      if (this.path) {
        this.model.removeRef(key);
        _model2.default.del(this.path);
      } else {
        this.model.del(key);
      }
    }
  }, {
    key: '_fetch',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(firstItem) {
        var _this2 = this;

        var promise;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(this.options.debounce && !firstItem)) {
                  _context2.next = 5;
                  break;
                }

                _context2.next = 3;
                return new _promise2.default(function (resolve) {
                  return setTimeout(resolve, _this2.options.debounce);
                });

              case 3:
                if (!this.cancelled) {
                  _context2.next = 5;
                  break;
                }

                return _context2.abrupt('return');

              case 5:
                promise = this.fn.apply(this, (0, _toConsumableArray3.default)(this.inputs));

                if (promise && typeof promise.then === 'function') {
                  _context2.next = 8;
                  break;
                }

                throw new Error('[react-sharedb] Api: fn must return promise');

              case 8:
                _context2.next = 10;
                return promise.then(function (data) {
                  if (_this2.cancelled) return;
                  _this2.data = data;
                });

              case 10:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _fetch(_x2) {
        return _ref3.apply(this, arguments);
      }

      return _fetch;
    }()
  }, {
    key: 'destroy',
    value: function destroy() {
      // this.unrefModel() // TODO: Maybe enable unref in future
      delete this.path;
      delete this.fn;
      delete this.inputs;
      delete this.options;
      delete this.data;
      (0, _get3.default)(Local.prototype.__proto__ || (0, _getPrototypeOf2.default)(Local.prototype), 'destroy', this).call(this);
    }
  }]);
  return Local;
}(_Base3.default);

exports.default = Local;
module.exports = exports['default'];